{# SPDX-License-Identifier: GPL-2.0-or-later #}
{# Copyright (c) 2022 Association Prologin <association@prologin.org> -#}
{# Copyright (c) 2022 Léo Lanteri Thauvin -#}
// {{ stechec2_generated }}

{% for constant in game.constant %}
{{ constant.cst_comment|js_doc_comment }}
declare const {{ constant.cst_name }}: {{ constant.cst_type|ts_type }} = {{ constant.cst_val }};

{% endfor %}
{% for enum in game.enum %}
{{ enum.enum_summary|js_doc_comment }}
declare enum {{ enum.enum_name|camel_case }} {
    {% for field_name, field_comment in enum.enum_field %}
    {{ field_comment|js_doc_comment(indent=4) }}
    {{ field_name|camel_case }} = {{ loop.index0 }},
    {% endfor %}
}

{% endfor %}
{% for struct in game.struct %}
{% if not struct is tuple %}
{{ struct.str_summary|js_doc_comment }}
declare interface {{ struct.str_name|camel_case }} {
    {% for field_name, field_type, field_comment in struct.str_field %}
    {{ field_comment|js_doc_comment(indent=4) }}
    {{ field_name|camel_case(upper=False) }}: {{ field_type|ts_type }};
    {% endfor %}
}
{% else %}
{{ struct|js_doc_tuple }}
declare type {{ struct.str_name|camel_case }} = {{ struct|ts_tuple_type }};
{% endif %}

{% endfor %}
{% for func in game.function %}
{{ func|js_doc_function }}
declare function {{ func|ts_func_signature }};

{% endfor %}
